using System.Buffers;
using System.Globalization;

using Spectre.Console.Cli;

namespace Geekeey.Extensions.Process.Tests.Dummy.Commands;

internal sealed class LengthCommand : Command<LengthCommand.Settings>
{
	public sealed class Settings : CommandSettings
	{
	}

	public override int Execute(CommandContext context, Settings settings)
	{
		using var buffer = MemoryPool<byte>.Shared.Rent(81920);
		using var stdin = Console.OpenStandardInput();

		var count = 0L;
		while (true)
		{
			var bytesRead = stdin.Read(buffer.Memory.Span);
			if (bytesRead <= 0)
				break;

			count += bytesRead;
		}

		Console.Out.WriteLine(count.ToString(CultureInfo.InvariantCulture));
		return 0;
	}
}