using System.Runtime.InteropServices;
using System.Runtime.Versioning;

namespace Geekeey.Extensions.Process;

internal partial class ProcessHandle
{
	[SupportedOSPlatform("freebsd")]
	[SupportedOSPlatform("linux")]
	[SupportedOSPlatform("macOS")]
	private bool SendPosixSignal(PosixSignals signal)
	{
		return Posix.Kill(Id, (int)signal) is 0;
	}

	[SupportedOSPlatform("freebsd")]
	[SupportedOSPlatform("linux")]
	[SupportedOSPlatform("macOS")]
	internal static partial class Posix
	{
		[LibraryImport("libc", EntryPoint = "kill", SetLastError = true)]
		internal static partial int Kill(int pid, int sig);
	}

	private enum PosixSignals : int
	{
		SIGINT = 2,
		SIGTERM = 15
	}
}